
#include "markers.h"

/* void    alloc_xxgg  (int nl, int nped)     xx0, xx1, gg0, gg1 in sample.h
 * void    free_xxgg   (void)
 *
 * int  ** alloc_genes (int nl, int nped)       called by alloc_xxgg, alloc_y
 * void    free_genes  (int *** a)            called by free_xxgg, free_y
 *
 * arrays are allocated [nloci + 1] x [pedsize + 1]
 */

void  alloc_xxgg (int nl, int nped)
{
   xx0 = alloc_genes (nl, nped);
   xx1 = alloc_genes (nl, nped);
   gg0 = alloc_genes (nl, nped);
   gg1 = alloc_genes (nl, nped);

   return;
}

void  free_xxgg (void)
{
   free_genes (&xx0);
   free_genes (&xx1);
   free_genes (&gg0);
   free_genes (&gg1);
}

int **alloc_genes (int nl, int nped)
{
   int   j;
   int **a;

   a = malloc ((nl + 1) * sizeof (int *));
   alloc_chk (WHERE, a);
   a[0] = calloc ((nped + 1) * (nl + 1), sizeof (int));
   alloc_chk (WHERE, a[0]);
   for (j = 1; j <= nl; ++j)
      a[j] = a[j - 1] + (nped + 1);

   return a;
}

void  free_genes (int ***a)
{
   if (*a)
   {
      free (**a);
      **a = NULL;
      free (*a);
      *a = NULL;
   }
   return;
}
