/*
 * $Id: comput_lods.c,v 1.1 2002/06/21 22:39:40 thompson Exp $
 *  Transferred from Quant to Markers library: EAT 2002
 */

#include "markers.h"

double comput_lods (double **matLR,
                    double *lods,
                    int numpos,
                    int method,
                    double *eigen2)
{
   double value = 1.0;
   double *likes = 0;
   int   i = 0;

   switch (method)
    {
       case 1:
          /* Left to right */
          for (i = 0; i < numpos; ++i)
          {
             value *= sqrt (matLR[i][i + 1] / matLR[i + 1][i]);
             lods[i] = log10 (value);
          }
          value *= sqrt (matLR[numpos][0] / matLR[0][numpos]);
          break;
       case 2:
          /* Right to left */
          value = sqrt (matLR[0][numpos] / matLR[numpos][0]);
          for (i = numpos - 1; i >= 0; --i)
          {
             lods[i] = log10 (value);
             value *= sqrt (matLR[i + 1][i] / matLR[i][i + 1]);
          }
          break;
       default:
          likes = malloc ((numpos + 1) * sizeof *likes);
          alloc_chk (WHERE, likes);
          /* Eigenvalue method */
          value = lik_eigen (matLR, likes, numpos + 1, eigen2);
          for (i = 0; i < numpos; ++i)
          {
             lods[i] = log10 (likes[0] / likes[i + 1]);
          }
          free (likes);
          break;
    }

   return value;
}
