
#include "markers.h"

/* Scoring of binary patterns over windows, for ibddrop and other
   programs; generalized for arb pattern scoring;   EAT Oct 2002  */

/*  Score ibd pattern of individual i */

int   ibd_pattern (int jj, int *proband, int *gamete)
{
   int   gene1, gene2;

   gene1 = gamete[0] == 0 ? gg0[jj][proband[0]] : gg1[jj][proband[0]];
   gene2 = gamete[1] == 0 ? gg0[jj][proband[1]] : gg1[jj][proband[1]];

   if (gene1 == gene2 && gene1 != 0)
      return (1);
   else
      return (0);
}

/* Score any binary pattern over windows  */

int   bin_pattern (int j, int ws, int *wl)
{
   int   jj;
   int   pt = 0;

   for (jj = j; jj < j + ws; ++jj)
      pt = 2 * pt + wl[jj];

   return (pt);
}

/*  Get binary ibd score for pattern nn  */

void  binary (int nn, int ws, int *ibd)
{
   int   j, k1, k2;

   k1 = nn;
   for (j = ws - 1; j >= 0; --j)
   {
      k2 = k1 / 2;
      ibd[j] = k1 - k2 * 2;
      k1 = k2;
   }
}
