
#include "markers.h"

static int ***sumgene;

int ***alloc_affhist (void)

/* allocs and initializes (to 0) hist[nc][nl][naff], 
 * where naff is the no.  affected individuals for the component
 * returns hist[][][]                                                         */

{
   int ***h;
   int   c, jj;
   COMPS_PTR pC;

   if (!NAffCmp)
      return NULL;

   h = malloc (NAffCmp * sizeof (int **));
   alloc_chk (WHERE, h);

   for (c = 0; c < NAffCmp; ++c)
      if (NAffInd[c])
      {
         h[c] = malloc (NLoci * sizeof (int *));
         alloc_chk (WHERE, h[c]);
         for (jj = 0; jj < NLoci; ++jj)
         {
            h[c][jj] = calloc (NAffInd[c], sizeof (int));
            alloc_chk (WHERE, h[c][jj]);
         }
      }
      else
         h[c] = NULL;

/* also allocs the static array sumgene[nc][nl][nlabl],
 * where nlabl is 2 * no. of founders for the component                       */

   sumgene = malloc (NAffCmp * sizeof (int **));
   alloc_chk (WHERE, sumgene);

   pC = pCompTab;
   for (c = 0; c < NAffCmp; ++c)
   {
      if (NAffInd[c])
      {
         sumgene[c] = malloc (NLoci * sizeof (int *));
         alloc_chk (WHERE, sumgene[c]);
         for (jj = 0; jj < NLoci; ++jj)
         {
            sumgene[c][jj] = malloc (2 * pC->nFound * sizeof (int));
            alloc_chk (WHERE, sumgene[c][jj]);
         }
      }
      else
         sumgene[c] = NULL;
      ++pC;
   }

   return h;
}

void  score_aff (int ***hist)

/* founder couple in simL ped are #3 and #4, so genes are 5,6,7,8 probably */
{
   int   c, jj, i, k, mx, n;
   COMPS_PTR pC;

   if (!NAffCmp)
      return;

   pC = pCompTab;
   for (c = 0; c < NAffCmp; ++c)
   {
      if (NAffInd[c])
         for (jj = 0; jj < NLoci; ++jj)
            for (k = 0; k < 2 * pC->nFound; ++k)
               sumgene[c][jj][k] = 0;
      ++pC;
   }
   /*                                      for each locus, counts the no. of 
    *                                      inheritances of ea label by
    *                                      affected individuals
    *                                      (note OR of gg0 and gg1)           */
   pC = pCompTab;
   n = 1;

   for (c = 0; c < NAffCmp; ++c)
   {
      if (NAffInd[c])
         for (jj = 0; jj < NLoci; ++jj)
            for (i = 0; i < NAffInd[c]; ++i)
               for (k = 0; k < 2 * pC->nFound; ++k)
                  if (gg0[jj][AffIx[c][i]] == n + k + 1
                      || gg1[jj][AffIx[c][i]] == n + k + 1)
                     ++sumgene[c][jj][k];
      ++pC;
      n += 2 * pC->nFound;
   }

#if 0
   /*                                      alternate code for sumgene:          
    *                                      for inbred peds, counts the
    *                                      NUMBER of copies of founder genes
    *                                      in individuals                     */
   {
      if (gg0[jj][AffIx[c][i]] == n + k + 1)
         ++sumgene[c][jj][k];
      if (gg1[jj][AffIx[c][i]] == n + k + 1)
         ++sumgene[c][jj][k];
   }
#endif

   pC = pCompTab;

   for (c = 0; c < NAffCmp; ++c)
   {
      if (NAffInd[c])
         for (jj = 0; jj < NLoci; ++jj)
         {
            mx = 0;
            for (k = 0; k < 2 * pC->nFound; ++k)
               if (sumgene[c][jj][k] > mx)
                  mx = sumgene[c][jj][k];
            ++hist[c][jj][mx - 1];      /* 0 < mx <= NAffInd[c]               */
         }
      ++pC;
   }

#if 0                                   /* (abandoned code)                   */
   if (jj == 0)
      nuc = mx;
   else if (mx > nuc)
      ++scmark[jj];
#endif

   return;
}
