/* set_markdat(), set_traitdat(), set_probgam()               MAJ Aug/01   */
/* moved to Msample library.                                  EAT Feb 02   */
/* set_markdat() moved to set_traits.c                        EAT Mar 02   */
/* set_pedaff() added                                         MAJ MAY 03   */
/* printout from set_traitdat() moved to prnt_traitdat()      MAJ JAN 04   */

#include "markers.h"

void  set_traitdat (int ***yy, int *qdex, int *trtphen, int pdsz, int nc)
{
   int   c, k, i, np;

   np = 0;
   for (c = 0; c < nc; ++c)
   {
      for (k = 4; k > 0; --k)           /* k=0 unknown        */
      {
         for (i = 0; i < pdsz; ++i)
         {
            if (nghd[i].component == c + 1 && data[i][5] == k)
            {
               if (TraitPheno)          /* ADDED CODE, EAT 9/00 & 10/00 */
               {
                  ++np;
                  qdex[i] = np;
                  trtphen[i] = data[i][5];
               }
               else
               {
                  if (k == 4)           /* recessive affected */
                  {
                     yy[0][0][i] = 2;
                     yy[1][0][i] = 2;
                  }
                  else if (k == 3)      /* recessive carrier  */
                  {
                     yy[0][0][i] = 1;
                     yy[1][0][i] = 2;
                  }
                  else if (k == 1)      /*  homozyyg normal    */
                  {
                     yy[0][0][i] = 1;
                     yy[1][0][i] = 1;
                  }
                  else
                  {
                     yy[0][0][i] = 0;
                     yy[1][0][i] = 0;
                  }
                  if (k == 2)           /* phenotypic normal for recessive    */
                     continue;          /* trait not implemented              */
               }
            }
         }
      }
   }
   return;
}

void  prnt_traitdat (int ***yy, int pdsz, int nc)
{
   int   c, k, i, ifound, kfound;

   char *k_txt[5] =
   {
      "",
      "(homozygous normal)",
      "(not implemented)",
      "(heterozygote)",
      "(homozygous affected)"
   };

   printf (" Trait data:\n");

   for (c = 0; c < nc; ++c)
   {
      kfound = 0;
      printf ("\n Component %d:\n", c + 1);
      for (k = 4; k > 0; --k)           /* k=0 unknown        */
      {
         ifound = 0;

         for (i = 0; i < pdsz; ++i)
         {
            if (nghd[i].component == c + 1 && data[i][5] == k)
            {
               if (TraitPheno)
               {
                  kfound = 1;
                  if (!ifound)
                     printf ("\n    phenotype %d:", data[i][5]);
                  if (!(ifound % 6))
                     printf ("\n   ");
                  ++ifound;
                  printf (" %s", nghd[i].self);
               }
               else
               {
                  if (k == 4 || k == 3 || k == 1)
                     kfound = 1;
                  if (!ifound)
                     printf ("\n    genotype %d %d %s:",
                             yy[0][0][i], yy[1][0][i], k_txt[k]);
                  if (!(ifound % 6))
                     printf ("\n   ");
                  ++ifound;
                  printf (" %s", nghd[i].self);
               }
            }
         }
         if (ifound)
            printf ("\n");
      }
      if (!kfound)
         printf ("    no trait data\n");
   }
   printf ("\n\n");
   fflush (stdout);

   return;
}

int   set_probgam (int nc)
{
   int   c, s, k, i;
   int   npc = 0;

   for (c = 0; c < nc; ++c)             /* for each component  */
      if (NScCmp < c + 1)
         give_warn (ERA_ncd, c + 1);

      else if (!NScSet[c])
         give_warn (ERA_ncd, c + 1);

      else
      {
         ++npc;
         for (s = 0; s < NScSet[c]; ++s)  /* and each scoreset                */
            for (k = 0; k < NPrGam[c][s]; ++k)
            {                           /* gets indices to data[][]           */
               if ((i = get_posit (ProbNam[c][s][k])) == INVALID_INDEX)
                  give_up (ERA_inp, ProbNam[c][s][k]);
               else if ((nghd[i].component) != (c + 1))
                  give_up (ERA_pnc, ProbNam[c][s][k], c + 1,
                           nghd[i].component);

               ProbIx[c][s][k] = i;
            }
      }
   if (!npc)                            /* checks for any proband gametes     */
      give_up_where (WHERE, ERA_mpg);
   else if (NScCmp > nc)
      give_warn (ERA_mcd, NScCmp, nc);

   return nc < NScCmp ? nc : NScCmp;
}

void  set_pedaff (int ***yy, int nc)
{
   int   c, i, k;
   int   nac = 0;

   if (AffTrIn)                         /* Affecteds to be found in ped file  */
   {
      NAffCmp = nc;

      NAffInd = malloc (NAffCmp * sizeof (int));  /* allocs for components    */
      alloc_chk (WHERE, NAffInd);
      AffIx = malloc (NAffCmp * sizeof (int *));
      alloc_chk (WHERE, AffIx);
      AffNam = malloc (NAffCmp * sizeof (char **));
      alloc_chk (WHERE, AffNam);
      for (c = 0; c < nc; ++c)
         NAffInd[c] = 0;

      for (i = 0; i < pedsize; ++i)     /* counts no. affecteds in ea compnt  */
         if (data[i][5] == 3 || data[i][5] == 4)
         {
            ++NAffInd[nghd[i].component - 1];
            ++nac;
         }
      for (c = 0; c < nc; ++c)          /* for each component:                */
         if (NAffInd[c])
         {
            AffIx[c] = malloc (NAffInd[c] * sizeof (int));
            alloc_chk (WHERE, AffIx[c]);
            AffNam[c] = malloc (NAffInd[c] * sizeof (char *));
            alloc_chk (WHERE, AffNam[c]);
            for (k = 0; k < NAffInd[c]; ++k)
            {
               AffNam[c][k] = malloc ((MAXNAMLEN + 1) * sizeof (char));
               alloc_chk (WHERE, AffNam[c][k]);
            }
            k = 0;
            for (i = 0; i < pedsize; ++i)
            {
               if (data[i][5] != 0 && nghd[i].component == c + 1)
               {
                  yy[0][0][i] = 0;
                  yy[1][0][i] = 0;

                  if (data[i][5] == 3 || data[i][5] == 4)
                  {
                     AffIx[c][k] = i;   /* sets index to data[][] and name    */
                     strncpy (AffNam[c][k], nghd[i].self, MAXNAMLEN);
                     ++k;
                  }
               }
            }
         }
         else
         {
            AffIx[c] = NULL;
            AffNam[c] = NULL;
            give_warn (ERA_nff, c + 1);
         }
      if (!nac)
         give_up (ERA_nap, nc);
      print_affind ();
   }
   else
   {                                    /* Affecteds in parameter file        */
      for (c = 0; c < nc; ++c)          /* for each component:                */
      {
         if (NAffCmp < c + 1)
            give_warn (ERA_naf, c + 1);

         else if (!NAffInd[c])
            give_warn (ERA_naf, c + 1);
         else
         {
            ++nac;
            for (k = 0; k < NAffInd[c]; ++k)  /* gets the data[][] indices    */
            {
               if ((i = get_posit (AffNam[c][k])) == INVALID_INDEX)
                  give_up (ERA_nip, AffNam[c][k]);
               else if ((nghd[i].component) != (c + 1))
                  give_up (ERA_nic, AffNam[c][k], c + 1, nghd[i].component);

               AffIx[c][k] = i;
            }
         }
      }
      if (NAffCmp > nc)
         give_warn (ERA_mca, NAffCmp, nc);
      if (!nac)
         give_up (ERA_naa, nc);
   }
   return;
}
