/*  functions are:
 *        assignChron()
 *        checkChron()
 *        newChron()
 *        reassignIX()
 *        reassignChron()
 */
#include "pedchk.h"

void  OLDassignChron (void)
{
   int   nThisLoop;
   int   nChron = 0;
   KEYS_PP ppK;

   for (ppK = ppKeyTab; ppK < ppKeyTab + nInd; ++ppK)
      if ((*ppK)->founder)              /* assigns chronological no's  */
         (*ppK)->chron = ++nChron;      /* to founders                 */
   do
   {                                    /* non-founder:                */
      nThisLoop = 0;                    /* tests for ma & pa already   *
                                         * assigned chronological no.  */
      for (ppK = ppKeyTab; ppK < ppKeyTab + nInd; ++ppK)
         if (!(*ppK)->chron)
            if ((*(ppKeyTab + (*ppK)->ixMa - 1))->chron &&
                (*(ppKeyTab + (*ppK)->ixPa - 1))->chron)
            {
               (*ppK)->chron = ++nChron;
               ++nThisLoop;
            }
   }
   while (nThisLoop);

   return;
}
void  assignChron (void)
{
   int   nThisLoop;
   int   nChron = 0;
   KEYS_PP ppK;

   do                                   /* founders:  chronlogical no.     *
                                         * assigned on first pass          *

                                         * non-founder: tests for ma & pa  *
                                         * already assigned chron no.      */
   {
      nThisLoop = 0;

      for (ppK = ppKeyTab; ppK < ppKeyTab + nInd; ++ppK)
         if (!(*ppK)->chron)
            if ((*ppK)->founder ||
                ((*(ppKeyTab + (*ppK)->ixMa - 1))->chron &&
                 (*(ppKeyTab + (*ppK)->ixPa - 1))->chron))
            {
               (*ppK)->chron = ++nChron;
               ++nThisLoop;
            }
   }
   while (nThisLoop);

   return;
}
int   checkChron (void)
{
   int   noChron = 0;
   char  fNam[MAXNAMLEN + 1] = "\0";

   KEYS_PP ppK;

   for (ppK = ppKeyTab; ppK < ppKeyTab + nInd; ++ppK)
      if (!(*ppK)->chron)
      {
         ++noChron;
         if (fNam[0] == '\0')
            strncpy (fNam, (*ppK)->nam, MAXNAMLEN + 1);
      }

   if (noChron == 0)
      return OK;

   if (noChron == 1)
      give_err (ERC_ch1, "checkChron", fNam);
   else
      give_err (ERC_chr, "checkChron", noChron, fNam);

   return !OK;
}
int   newChron (void)
{
   KEYS_PP ppK;

   for (ppK = ppKeyTab; ppK < ppKeyTab + nInd; ++ppK)
      if ((*ppK)->ix != (*ppK)->chron)
         return TRUE;

   return FALSE;
}
void  reassignIx (void)
{
   /* Assumes KeyTab is sorted in chronological order
      Reassigns index to be chronological order      */
   KEYS_PP ppK;
   for (ppK = ppKeyTab; ppK < ppKeyTab + nInd; ++ppK)
   {
      /* reassign ix */
      (*ppK)->ix = (*ppK)->chron;
      /* reassign parents ix */
      if ((*ppK)->ixMa != 0)
         (*ppK)->ixMa = (*(ppKeyTab + (*ppK)->ixMa - 1))->chron;
      if ((*ppK)->ixPa != 0)
         (*ppK)->ixPa = (*(ppKeyTab + (*ppK)->ixPa - 1))->chron;
   }
   return;
}
void  reassignChron (void)
{
   /* Assumes KeyTab is sorted in new chronological order (by component)
      Reassigns chron                                                   */
   KEYS_PP ppK;

   int   n = 0;

   for (ppK = ppKeyTab; ppK < ppKeyTab + nInd; ++ppK)
      (*ppK)->chron = ++n;

   return;
}
