
#include "pedchk.h"

int   mak_opedfil (void)

/* writes out the pedigree data, previously read by readPed,            */
/* if it is not in input order, or if the record contents differ        */
/* sets the input pedigree file name to the name of this file           */

{
   FILE *oPedF;

   int   i;
   int   msg[3] =
   {N, N, N};
   /*                                      check for changes to file    */
   if (newChron ())
      msg[0] = ERC_cco;
   if (SexOp == ASSIGN || SexOut != SexIn)
      msg[1] = ERC_csa;
   if (ObsOp == ALL || ObsOut != ObsIn)
      msg[2] = ERC_coi;

   if (msg[0] || msg[1] || msg[2])
   {
      for (i = 0; i <= 2; ++i)
         if (msg[i])
            give_warn (msg[i]);
      give_warn (ERC_wpf);

      if (!(oPedF = openChkPed ()))     /* opens the output file        */
         return !OK;

      writChkPed (oPedF);               /* writes out the pedigree data */
      fclose (oPedF);
      if (!(assignChkPed ()))           /* sets the input file name to  */
         return !OK;                    /* the output file name         */
   }
   freeChkPed ();                       /* frees data structures        */

   if (newChron ())
   {
      sortIx ();                        /* reassign input order to be   */
      reassignIx ();                    /* the same as chronological    */
      sortComp ();                      /* order, by component          */
   }

   fprintf (stdout, " === Checking of pedigree file completed ===\n\n\n");

   return OK;
}
