
#include "lsample.h"

/* routines here set the quantitative trait locus information,
   The routine replace version of schnell routines as indicated,
   -- but actually doing the transfer for schnell shoudl await a
   working schnell  */

double set_quant_trait (int nloc)
{                                       /* This routine sets the parameters of the QTL    */
   /* It should replace schl_set_traitdat () for schnell  */
   /* Here we assume there is only one trait */
   int   i, j, m_geno;
   double mu;
   /* allele frequencies */
   double f1, f2, pve, pva;
   TPARS_PTR ptrait = PTraitPars;
   fflush (stdout);
   for (j = 0; j <= nloc; ++j)
      if (loci[j].locus_type == TRAIT_LOCUS)
      {
         loci[j].ve = ptrait->resi_term * ptrait->resi_term;
         loci[j].va = ptrait->addi_term_found * ptrait->addi_term_found;
         printf ("\n  Residual variance = %f, Additive Variance = %f\n",
                 loci[j].ve, loci[j].va);

         i = loci[j].n_all;
         if (i != 2)
         {
            fprintf (stderr,
                     "Error: expect 2 alleles for the trait, got %d!\n",
                     i);
         }
         f1 = loci[j].freq[0];
         f2 = loci[j].freq[1];
         /* given three genotypic means, use allele frequencies to compute
          * global means, assuming there are only two alleles for the trait
          * */
         mu = f1 * f1 * ptrait->means[0] +
            2.0 * f1 * f2 * ptrait->means[1] +
            f2 * f2 * ptrait->means[2];
         printf ("  Trait global mean = %f\n", mu);
         printf ("  Trait Id %d: no of alleles = %d\n", j, i);
         m_geno = i * (i + 1) / 2;
         for (i = 0; i < m_geno; i++)
         {
            loci[j].g_mu[i] = ptrait->means[i] - mu;
            printf ("    Genotype %d, deviation from mean: %f \n", i,
                    loci[j].g_mu[i]);
         }
      }
   fflush (stdout);
   return (mu);
}

/* sets the centered phenotypic trait values.
   The routine replace schnell code as indicated,
   -- but actually doing the transfer for schnell should await a
   working schnell  */

       /* this should replace code in main schnell.c program   */

void  alloc_quantdat (int np)
/* allocates space and sets values of the centered phenotypic values */
{
   int   j;
   ym = malloc ((np + 1) * sizeof (double));
   alloc_chk (WHERE, ym);
   ym[0] = 0.0;

   return;
}
